<?php
/**
 * Created by PhpStorm.
 * User: Desenv-005
 * Date: 19/12/2018
 * Time: 17:37
 */

namespace Schaffen\ProductionOrder\ProductionOrder\Services;

use Schaffen\Core\Product\Managers\ProductVarietyPackManager;
use Schaffen\ProductionOrder\ProductionOrder\Managers\ProductionOrderItemManager;
use Schaffen\ProductionOrder\ProductionOrder\Managers\ProductionOrderManager;
use Schaffen\WarehouseInventory\WarehouseInventory\Managers\SnapshotInventoryManager;
use Schaffen\WarehouseInventory\WarehouseInventory\Managers\WarehouseInventoryManager;

class CreateProductionOrder
{
    private $product_variety_pack_manager;
    private $snapshot_inventory_manager;
    private $warehouse_inventory_manager;
    private $production_order_manager;
    private $production_order_item_manager;

    const OUT = 0;
    const IN = 1;
    const INVENTORY_TYPE = "ORDEM_PRODUCAO";

    public function __construct(
        ProductVarietyPackManager $product_variety_pack_manager,
        SnapshotInventoryManager $snapshot_inventory_manager,
        WarehouseInventoryManager $warehouse_inventory_manager,
        ProductionOrderManager $production_order_manager,
        ProductionOrderItemManager $production_order_item_manager
    )
    {
        $this->product_variety_pack_manager = $product_variety_pack_manager;
        $this->snapshot_inventory_manager = $snapshot_inventory_manager;
        $this->warehouse_inventory_manager = $warehouse_inventory_manager;
        $this->production_order_manager = $production_order_manager;
        $this->production_order_item_manager = $production_order_item_manager;
    }

    /**
     * @return SnapshotInventoryManager
     */
    public function getSnapshotInventoryManager(): SnapshotInventoryManager
    {
        return $this->snapshot_inventory_repository;
    }

    /**
     * @return WarehouseInventoryManager
     */
    public function getWarehouseInventoryManager(): WarehouseInventoryManager
    {
        return $this->warehouse_inventory_repository;
    }

    public function createProductionOrder(array $input = [])
    {
        $input_collected = collect($input);
        $this->production_order_manager->storeOrUpdate($input);

        if ($input_collected->has('composition')) {

            foreach ($input_collected['composition'] as $composition) {
                $this->production_order_item_manager->storeOrUpdate($composition, $composition['pcp_codigo'] ?? NULL);
            }

        }


    }

}
